import requests
import re
from collections import defaultdict

class Properties:
	def __init__(self, qid):
		self.id = qid
		self.URL = "https://www.wikidata.org/w/api.php"
		self.entityDict= defaultdict(list)
		self.dictVal = ''
		self.getProps(self.id)

	def getdesc(self, entityid, toReturn, timeLabel):
		ePARAMS = {
			"action": "wbgetentities",
			"format": "json",
			"ids": entityid,
			"languages": "en"
		}
		U = requests.Session()
		T = U.get(url=self.URL, params=ePARAMS)
		eDATA = T.json()
		if toReturn == 1:
			try :
				eVal = eDATA['entities'][entityid]['labels']['en']['value']
			except:
				eVal = eDATA['entities'][entityid]['labels']['value']
		else:
			if entityid[0] == 'L':
				eVal = ''.join([eDATA['entities'][entityid]['lemmas']['en']['value'], timeLabel])
			elif entityid[0] == 'Q':
				eVal = ''.join([eDATA['entities'][entityid]['labels']['en']['value'], timeLabel])
		return(eVal)

	def getProps(self, entityID):
		ePARAMS = {
			"action": "wbgetentities",
			"format": "json",
			"ids": entityID,
		}
		U = requests.Session()
		T = U.get(url=self.URL, params=ePARAMS)
		eDATA = T.json()
		entity = eDATA['entities'][entityID]['claims']
		entityProperties = list(entity.keys())
		timeLabel = ''
		for key in range(len(entityProperties)):
			entityProp = entityProperties[key]
			entity = eDATA['entities'][entityID]['claims'][entityProperties[key]]
			try:
				res = [ sub['mainsnak']['datavalue']['value'] for sub in entity ]
			except:
				self.dictVal = 'no value'
				self.entityDict[entityProp].append(self.dictVal)
				continue
			for i in range(len(res)):
				timeLabel = ''
				pointinTime = ''
				startTime = ''
				endTime = ''		
				propertyString = ''

				propertyString = str(res[i])

				try:
					pointinTime = ' pointinTime: ' + entity[i]['qualifiers']['P585'][0]['datavalue']['value']['time']
				except:
					pointinTime = ''
				try:
					startTime = ' startTime: ' + entity[i]['qualifiers']['P580'][0]['datavalue']['value']['time']
				except:
					startTime = ''
				try:
					endTime = ' endTime: ' + entity[i]['qualifiers']['P582'][0]['datavalue']['value']['time']
				except:
					endTime =''
					
				timeLabel = pointinTime + startTime + endTime
				
				try:
					if 'time' in res[i]:
						dicto = res[i]
						self.dictVal = ''.join([str(dicto['time']), str(timeLabel)])
						self.entityDict[entityProp].append(self.dictVal)
					elif 'id: ' in res[i]:
						dicto = res[i]
						prop = getdesc(entityProperties[key], str(dicto['id']), 0, timeLabel)
						self.dictVal = str(prop)
						self.entityDict[entityProp].append(self.dictVal)
					elif 'amount' in res[i]:
						dicto = res[i]
						unit = str(dicto['unit'])
						if unit != '1':
							unit = re.search('http://www.wikidata.org/entity/(.*)', unit)
							unit = unit.group(1)
							unit = self.getdesc(unit, 1, timeLabel)
							self.dictVal = ''.join([str(dicto['amount']), ' ', str(unit), str(timeLabel)])
							self.entityDict[entityProp].append(self.dictVal)
						else:
							self.dictVal = ''.join([str(dicto['amount']), str(timeLabel)])
							self.entityDict[entityProp].append(self.dictVal)
					elif 'numeric-id' in res[i]:
						dicto = res[i]
						setID = str(dicto['id'])
						self.dictVal = self.getdesc(setID, 0, timeLabel)
						self.entityDict[entityProp].append(self.dictVal)
					elif 'text' in res[i]:
						dicto = res[i]
						if isinstance(dicto, str):
							self.dictVal = ''.join([dicto, str(timeLabel)])
						else:
							self.dictVal = ''.join([str(dicto['text']), str(timeLabel)])
						self.entityDict[entityProp].append(self.dictVal)
					elif 'form' in res[i]:
						dicto = res[i]
						self.dictVal = ''.join([str(dicto['id']), str(timeLabel)])
						self.entityDict[entityProp].append(self.dictVal)
					else:
						self.dictVal = ''.join([str(propertyString), str(timeLabel)])
						self.entityDict[entityProp].append(self.dictVal)
				except Exception as e:
					self.dictVal = ''.join([str(dicto['id']), str(timeLabel)])
					self.entityDict[entityProp].append(self.dictVal)

if __name__ == '__main__':
	e = Properties('Q23')
	print(e.entityDict)